package com.smppw.analysis.application.service.position;

import cn.hutool.core.map.MapUtil;
import com.smppw.analysis.domain.manager.position.future.FundFuturesOptionBaseService;
import com.smppw.common.pojo.ResultVo;
import com.smppw.common.pojo.enums.status.ResultCode;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * FileName: FundFuturesOptionService
 * Author:   chenjianhua
 * Date:     2023/6/8 14:11
 * Description: ${DESCRIPTION}
 */
@Component
public class FundFuturesOptionService {

    @Autowired
    private FundFuturesOptionBaseService fundFuturesOptionBaseService;

    public ResultVo<Map<String, Object>> fundFuturesOption(Map<String, Object> params) {
        Integer userId = MapUtil.getInt(params, "userId");
        String fundId = MapUtil.getStr(params, "fundId");
        Integer optionType = MapUtil.getInt(params, "optionType");
        Integer shType = MapUtil.getInt(params, "shType");
        String startDate = MapUtil.getStr(params, "startDate");
        String endDate = MapUtil.getStr(params, "endDate");
        Map<String, Object> result = fundFuturesOptionBaseService.fundFuturesOption(userId, fundId, optionType, shType, startDate, endDate);
        return new ResultVo<>(ResultCode.SUCCESS, result);
    }

    public ResultVo<Map<String, Object>> fundPositionAnalysis(Map<String, Object> params) {
        Integer userId = MapUtil.getInt(params, "userId");
        String fundId = MapUtil.getStr(params, "fundId");
        Integer optionType = MapUtil.getInt(params, "optionType");
        Integer shType = MapUtil.getInt(params, "shType");
        String startDate = MapUtil.getStr(params, "startDate");
        String endDate = MapUtil.getStr(params, "endDate");
        Map<String, Object> result = fundFuturesOptionBaseService.fundPositionAnalysis(userId, fundId, optionType, shType, startDate, endDate);
        return new ResultVo<>(ResultCode.SUCCESS, result);
    }

    public ResultVo<Map<String, Object>> fundDerivativeLeverageMargin(Map<String, Object> params) {
        Integer userId = MapUtil.getInt(params, "userId");
        String fundId = MapUtil.getStr(params, "fundId");
        Integer optionType = MapUtil.getInt(params, "optionType");
        Integer shType = MapUtil.getInt(params, "shType");
        String startDate = MapUtil.getStr(params, "startDate");
        String endDate = MapUtil.getStr(params, "endDate");
        Map<String, Object> result = fundFuturesOptionBaseService.fundDerivativeLeverageMargin(userId, fundId, shType, startDate, endDate);
        return new ResultVo<>(ResultCode.SUCCESS, result);
    }

    public ResultVo<Map<String, Object>> fundPositionAnalysisLine(Map<String, Object> params) {
        Integer userId = MapUtil.getInt(params, "userId");
        String fundId = MapUtil.getStr(params, "fundId");
        Integer optionType = MapUtil.getInt(params, "optionType");
        Integer shType = MapUtil.getInt(params, "shType");
        String startDate = MapUtil.getStr(params, "startDate");
        String endDate = MapUtil.getStr(params, "endDate");
        Map<String, Object> result = fundFuturesOptionBaseService.fundPositionAnalysisLine(userId, fundId, optionType, shType, startDate, endDate);
        return new ResultVo<>(ResultCode.SUCCESS, result);
    }

    public ResultVo<Map<String, Object>> fundFuturesOptionForBreed(Map<String, Object> params) {
        Integer userId = MapUtil.getInt(params, "userId");
        String fundId = MapUtil.getStr(params, "fundId");
        Integer optionType = MapUtil.getInt(params, "optionType");
        Integer shType = MapUtil.getInt(params, "shType");
        String startDate = MapUtil.getStr(params, "startDate");
        String endDate = MapUtil.getStr(params, "endDate");
        Map<String, Object> result = fundFuturesOptionBaseService.fundFuturesOptionForBreed(userId, fundId, optionType, shType, startDate, endDate);
        return new ResultVo<>(ResultCode.SUCCESS, result);
    }

    public ResultVo<Map<String, List<String>>> fundFuturesOptionView() {
        Map<String, List<String>> result = fundFuturesOptionBaseService.fundFuturesOptionView();
        return new ResultVo<>(ResultCode.SUCCESS, result);
    }
}
